## START: Set by rpmautospec
## (rpmautospec version 0.6.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global _build_id_links none
%global __requires_exclude ^libjabber\\.so.*$
%global libcmatrix_commit 702b894675f12ecd43439b3b3eee66cc74899b82

Name: chatty
Version: 0.8.2
Release: %{autorelease}
Summary: A libpurple messaging client

License: GPL-3.0-or-later AND LGPL-2.1-or-later
URL: https://gitlab.gnome.org/World/Chatty
Source0: %{url}/-/archive/v%{version}/Chatty-v%{version}.tar.gz
Source1: https://source.puri.sm/Librem5/libcmatrix/-/archive/%{libcmatrix_commit}/libcmatrix-%{libcmatrix_commit}.tar.gz

# Chatty links against a libpurple private library (libjabber).
# Obviously, Fedora build tooling doesn't support that, so we have to use
# some kind of workaround. This seemed simplest.
# We do not want to provide a private library, which is from another
# project, to be used in other packages.
Patch0:  0001-hacky-hack.patch

ExcludeArch:    i686

BuildRequires:  gcc
BuildRequires:  meson
BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  dbus-daemon
BuildRequires:  dbus-x11
BuildRequires:  itstool
BuildRequires:  pkgconfig(libebook-contacts-1.2)
BuildRequires:  pkgconfig(libebook-1.2) >= 3.42.0
BuildRequires:  pkgconfig(libfeedback-0.0)
BuildRequires:  pkgconfig(libadwaita-1) >= 1.4
BuildRequires:  pkgconfig(gtk4) >= 4.12
BuildRequires:  pkgconfig(gio-2.0) >= 2.66
BuildRequires:  pkgconfig(gio-unix-2.0) >= 2.62
BuildRequires:  pkgconfig(purple)
BuildRequires:  pkgconfig(sqlite3) >= 3.26.0
BuildRequires:  pkgconfig(gee-0.8)
BuildRequires:  pkgconfig(folks)
BuildRequires:  pkgconfig(gsettings-desktop-schemas)
BuildRequires:  pkgconfig(gnome-desktop-4) >= 43
BuildRequires:  pkgconfig(libgcrypt)
BuildRequires:  pkgconfig(libsoup-3.0)
BuildRequires:  pkgconfig(json-glib-1.0)
BuildRequires:  pkgconfig(mm-glib) >= 1.12.0
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  gspell-devel
BuildRequires:  libolm-devel
BuildRequires:  libphonenumber-devel
BuildRequires:  protobuf-devel
BuildRequires:  libsecret-devel
BuildRequires:  libappstream-glib
BuildRequires:  desktop-file-utils
BuildRequires:  /usr/bin/xvfb-run
BuildRequires:  /usr/bin/xauth
BuildRequires:  at-spi2-core

Requires: hicolor-icon-theme

# Those packages may be dynamically loaded, but they depend on libsoup-2.4
# libsoup-2.4 and libsoup-3.0 can't exist in the same process
# Better to create a conflict, so user doesn't get a hard to debug error
Conflicts: purple-chime <= 1.4.1
Conflicts: purple-sipe <= 1.25.0

%description
Chatty is a libpurple based messaging client for mobile phones,
works best with the phosh mobile DE.

%prep

# Copy private libjabber library in so we can build against it
cp `pkg-config --variable=plugindir purple`/libjabber.so.0 /tmp/libjabber.so

%setup -a1 -n Chatty-v%{version}
%patch -P 0 -p1

rm -rf subprojects/libcmatrix
mv libcmatrix-%{libcmatrix_commit} subprojects/libcmatrix

%build
%meson
%meson_build

%check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/sm.puri.Chatty.metainfo.xml

desktop-file-validate %{buildroot}/%{_datadir}/applications/sm.puri.Chatty.desktop

# the upstream meson tests already validate the desktop file
# and the appstream file

LC_ALL=C.UTF-8 xvfb-run sh <<'SH'
%meson_test -t 2 --num-processes 1
SH

%install
%meson_install

# Adding libjabber to link against
mkdir -p %{buildroot}%{_libdir}
cp `pkg-config --variable=plugindir purple`/libjabber.so.0 %{buildroot}%{_libdir}

# Adding ld.so.conf.d in order to use the libjabber at runtime
mkdir -p %{buildroot}/%{_sysconfdir}/ld.so.conf.d
echo "%{_libdir}/chatty" > %{buildroot}/%{_sysconfdir}/ld.so.conf.d/chatty.conf

%find_lang purism-chatty

# The mesa vulkan bug breaks tests
# https://bugzilla.redhat.com/show_bug.cgi?id=1911130

%files -f purism-chatty.lang
%{_bindir}/chatty
%{_sysconfdir}/xdg/autostart/sm.puri.Chatty-daemon.desktop
%{_datadir}/glib-2.0/schemas/sm.puri.Chatty.gschema.xml
%{_datadir}/applications/sm.puri.Chatty.desktop
%{_datadir}/icons/hicolor/*/apps/sm.puri.Chatty*.svg
%{_metainfodir}/sm.puri.Chatty.metainfo.xml
%dir %{_datadir}/bash-completion
%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/chatty
%{_datadir}/help/C/chatty/index.page
%{_libdir}/libjabber.so.0
%{_sysconfdir}/ld.so.conf.d/chatty.conf
%doc README.md
%license COPYING

%changelog
## START: Generated by rpmautospec
* Tue Mar 26 2024 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.2-2
- Remove openssl1.1-devel dependency (fedora#2271571)

* Fri Mar 22 2024 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.2-1
- Upstream release 0.8.2

* Sun Jan 28 2024 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.1-1
- Upstream release v0.8.1 (fedora#2259895)

* Tue Jan 23 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.8.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.8.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Dec 27 2023 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.0-3
- Don't run tests in parallel

* Fri Dec 22 2023 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.0-2
- Drop exclusion of arch ppc64le

* Fri Dec 22 2023 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.0-1
- Upstream release v0.8.0

* Fri Dec 22 2023 Tomi Lähteenmäki <lihis@lihis.net> - 0.8.0~rc0-2
- Convert license to SPDX

* Sun Aug 06 2023 torbuntu <torbuntu@fedoraproject.org> - 0.8.0~rc0-1
- Update to 0.8.0

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed May 17 2023 Sérgio M. Basto <sergio@serjux.com> - 0.7.3-2
- Rebuild for libphonenumber-8.13.x

* Tue May 16 2023 torbuntu <torbuntu@fedoraproject.org> - 0.7.3-1
- Update to 0.7.3

* Tue Mar 14 2023 torbuntu <torbuntu@fedoraproject.org> - 0.7.2-1
- Update to 0.7.2

* Wed Feb 15 2023 torbuntu <torbuntu@fedoraproject.org> - 0.7.0-1
- Upgrade to 0.7.0

* Wed Jan 18 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0~rc5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Jan 10 2023 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc5-2
- exclude i686

* Tue Jan 10 2023 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc5-1
- Update to 0.7.0-rc5

* Fri Nov 18 2022 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc4-1
- Update to 0.7.0~rc4

* Fri Nov 11 2022 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc3-1
- Update to 0.7.0~rc3

* Mon Nov 07 2022 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc2-1
- Update to 0.7.0~rc2

* Fri Oct 21 2022 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc1-1
- Update to 0.7.0 rc1

* Wed Oct 19 2022 torbuntu <torbuntu@fedoraproject.org> - 0.7.0~rc0-1
- Update to 0.7.0 rc 0

* Sat Aug 13 2022 torbuntu <torbuntu@fedoraproject.org> - 0.6.7-3
- Patch for libsoup3

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 27 2022 torbuntu <sorensentor@tuta.io> - 0.6.7-1
- Update to chatty 0.6.7

* Sun Apr 24 2022 torbuntu <torbuntu@fedoraproject.org> - 0.6.3-1
- update to 0.6.3

* Fri Feb 25 2022 torbuntu <torbuntu@fedoraproject.org> - 0.6.2-1
- Update to 0.6.2

* Tue Feb 08 2022 torbuntu <torbuntu@fedoraproject.org> - 0.6.1-1
- update to 0.6.1

* Tue Jan 25 2022 torbuntu <torbuntu@fedoraproject.org> - 0.6.0-1
- Update to chatty 0.6.0

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.0~beta-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Jan 16 2022 torbuntu <sorensentor@tuta.io> - 0.6.0~beta-1
- Update to 0.6.0_beta

* Wed Dec 15 2021 torbuntu <sorensentor@tuta.io> - 0.5.0~beta4-1
- Update to 0.5.0_beta4

* Sat Dec 11 2021 torbuntu <torbuntu@fedoraproject.org> - 0.5.0~beta3-1
- Update to chatty 0.5.0_beta3

* Fri Dec 03 2021 torbuntu <torbuntu@fedoraproject.org> - 0.5.0~beta2-1
- Update to 0.5.0 beta 2

* Tue Nov 16 2021 torbuntu <torbuntu@fedoraproject.org> - 0.5.0~beta-1
- Update to 0.5.0_beta

* Sun Oct 31 2021 torbuntu <sorensentor@tuta.io> - 0.4.0-2
- Rebuild for deps

* Sat Sep 11 2021 torbuntu <sorensentor@tuta.io> - 0.4.0-1
- Update to chatty 0.4.0

* Tue Sep 07 2021 torbuntu <sorensentor@tuta.io> - 0.4.0~beta3-1
- Update to 0.4.0_beta3

* Mon Aug 30 2021 torbuntu <sorensentor@tuta.io> - 0.4.0~beta2-1
- Update to 0.4.0_beta2

* Wed Aug 25 2021 torbuntu <sorensentor@tuta.io> - 0.4.0~beta-1
- Update to 0.4.0_beta

* Thu Jul 29 2021 torbuntu <sorensentor@tuta.io> - 0.3.4-2
- Commit correct source files

* Thu Jul 29 2021 torbuntu <sorensentor@tuta.io> - 0.3.4-1
- Update to chatty 0.3.4

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jul 16 2021 torbuntu <sorensentor@tuta.io> - 0.3.3-1
- Update to chatty 0.3.3

* Tue Jun 29 2021 torbuntu <sorensentor@tuta.io> - 0.3.2-1
- Update to chatty 0.3.2

* Fri May 28 2021 torbuntu <sorensentor@tuta.io> - 0.3.1-1
- Update to 0.3.1

* Thu May 06 2021 torbuntu <sorensentor@tuta.io> - 0.3.0-2
- exclude ppc65le

* Thu May 06 2021 torbuntu <sorensentor@tuta.io> - 0.3.0-1
- Update to chatty 0.3.0

* Wed Apr 14 2021 torbuntu <sorensentor@tuta.io> - 0.3.0_beta2-1
- Update to chatty 0.3.0 beta 2

* Sun Mar 28 2021 torbuntu <sorensentor@tuta.io> - 0.3.0_beta-2
- Adding patch for e2e matrix room crashes

* Fri Mar 26 2021 torbuntu <sorensentor@tuta.io> - 0.3.0_beta-1
- Update version 0.3.0_beta

* Mon Mar 22 2021 torbuntu <sorensentor@tuta.io> - 0.2.0-1
- Initial push of Chatty
## END: Generated by rpmautospec
